/*
blinkin.cpp
main game functions ...

Copyright (C) 1995-2005  Everett Bell

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include "stdafx.h"
#include "resource.h"

#include "time.h"
#include "mmsystem.h"
// #include "wingdi.h"

#include <shlwapi.h>

// #include "cydoor.h"
// NOADS! ev 040104

// #define EDITORS
// #define SHAREWARE



HCURSOR	hcursor[2];

BOOL movingwindow = FALSE;


HANDLE debugfh;
char debugstr[128];
char debugstr2[128];

RECT screenrect, windowrect, adwindowrect;


// Debugging ...
#define TIMESTAMP			{ /*sprintf( debugstr2, "%.8d - GS: %.2d,  ", tickcount, gamescreen ); WriteFile( debugfh, debugstr2, strlen(debugstr2), &numofbytesread, NULL );*/ }
#define WRITETODEBUGFILE	{ TIMESTAMP; WriteFile( debugfh, debugstr, strlen(debugstr), &numofbytesread, NULL ); }


// Menu Globals ...
BOOL playnow = FALSE;
HWND hwndmenu;
int mouseover = 3;	// 4 = nothing
int oldmouseover = 3;
RECT splashrect[4];
int letterx[8], lettery[8];	// For title

HBITMAP hbmp_letter[8];
HBITMAP hbmp_splash[8];


#define MAX_LOADSTRING	100

#define INTERFACEWIDTH	120L
#define RSWIDTH			120L


#define UP		7
#define DOWN	2


#define MOVESY		104
#define STOPWATCHY	56

#define LEVELX		76
#define LEVELY		18
#define BESTMOVEX	42
#define BESTMOVEY	104
#define BESTTIMEX	34
#define BESTTIMEY	56



// cydoor Cydoor;
// BOOL adson = FALSE;



typedef struct hiscore_typ
{
	int randmoves[4];
	int randstopwatch[4];
	int randmin[4];
	int randsec[4];

	int setmoves[4][10];
	int setstopwatch[4][10];
	int setmin[4][10];
	int setsec[4][10];
} HISCORE;


BOOL insplashscreen = TRUE;
BOOL inmenu = TRUE;
BOOL centerwindow = 0;


LOGPALETTE logpalette;

int result;

MENUITEMINFO menuiteminfo;

HISCORE hiscore;
BOOL gothiscore;

int boardnumber = 0;	// 0-9

BYTE boardsave[8*8*40];
BYTE tempboardsave[8*8];
BOOL boardsaved = 0;

BOOL soundon = 1;


// Global Variables:

HPALETTE hPal, hSplashPal;
HPALETTE hOldPal;




HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// The title bar text

HANDLE filehandle;
char filename[MAX_PATH+1];
DWORD numofbytesread;

UINT clockid;
DWORD tickcount = 0;
DWORD newclock = 0;
DWORD stopwatch = 0;
int minutes = 0;
int seconds = 0;

BOOL stopwatchon = 0;
DWORD secondtimer = 32;
BYTE framespeed = 1;

int screenmaxx;
int screenmaxy;

int clientwidth = 200+INTERFACEWIDTH+RSWIDTH;
int clientheight = 200+40;

HDC memdc;
HBITMAP hbmp_vs;

BOOL updatingwindow = 1;
BOOL drawingstopwatch = 0;

TCHAR tempstr[1024];

HWND hwndmain;
HWND hwndad;

HACCEL hAccelTable;



DWORD windowstyle =
	   WS_MINIMIZEBOX |
	   WS_DLGFRAME |
	   WS_CAPTION |
	   WS_SYSMENU;



#define EASY	5
#define MEDIUM	6
#define HARD	7
#define GENIUS	8

BYTE difficulty = EASY;

BYTE randompuzzles = 0;


int numberofmoves;

BOOL goingup = 1;


// Bitmap Handles ...
HBITMAP hbmp_interface[4] = {0,0,0,0};
HBITMAP hbmp_rs[4] = {0,0,0,0};
HBITMAP hbmp_edge;
HBITMAP hbmp_reset[2];
HBITMAP hbmp_next[2];
int resetx = 20;
int resety = 250-55;
int nextx = 20;
int nexty = 250-55;
BOOL resetpushed = 0;
BOOL nextpushed = 0;

HBITMAP hbmp_light[8];
HBITMAP hbmp_digit[11];


BYTE isfading = 7;	// Represents frame
BYTE wingame = 0;
BYTE fadespeed = 1;

BYTE board[8*8];

BYTE boardfade[8*8];




// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

LRESULT CALLBACK	SplashWndProc(HWND, UINT, WPARAM, LPARAM);
BOOL				RunMenu( void );
ATOM				MenuRegisterClass(HINSTANCE hInstance);
void				DrawSplash( void );

LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	hiscoredialogfunc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	newhighdialogfunc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	sharewaredialogfunc(HWND, UINT, WPARAM, LPARAM);

HPALETTE			GetPalette( void ); // ditch
HPALETTE			CreateDIBPalette (LPBITMAPINFO lpbmi, LPINT lpiNumColors);
HBITMAP				LoadResourceBitmap(HINSTANCE hInstance, LPSTR lpString, HPALETTE FAR* lphPalette);

LRESULT				newgame( void );
LRESULT				updatewindow( void );
int					drawboard( void );

void				drawdigit( int digit, int x, int y );
void				drawnumberofmoves( void );
void				drawstopwatch( void );
void				drawrightsideinfo( void );

int					releaseobjects( void );

void CALLBACK		mytimer(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2);

// BOOL				openadwindow( void );
// BOOL				closeadwindow( void );

LRESULT CALLBACK	AdDialogProc ( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);






int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	MSG msg;

	HDC hdc, tempdc;
	DWORD newtickcount;

	PAINTSTRUCT ps;

	int slotno;


	debugfh = CreateFile("debug.log",           // create MYFILE.TXT 
         GENERIC_WRITE,                // open for writing 
         0,                            // do not share 
         NULL,                         // no security 
         CREATE_ALWAYS,                // overwrite existing 
         FILE_ATTRIBUTE_NORMAL |       // normal file 
         FILE_FLAG_SEQUENTIAL_SCAN,         // asynchronous I/O 
         NULL);                        // no attr. template 

	if( debugfh == INVALID_HANDLE_VALUE ) return FALSE;

	sprintf( debugstr, "Game Start ...\n\n" );

	if( !WriteFile( debugfh, debugstr, strlen(debugstr), &numofbytesread, NULL ) )
		return FALSE;



	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_LIGHTS, szWindowClass, MAX_LOADSTRING);

	MyRegisterClass(hInstance);
	MenuRegisterClass(hInstance);

	memset( boardfade, UP, 8*8 );


// Load High Scores ...
	ZeroMemory( &hiscore, sizeof(HISCORE) );


	sprintf( filename, "hiscore.dat" );

	filehandle = CreateFile( filename,           // open MYFILE.TXT 
                GENERIC_READ,              // open for reading 
                FILE_SHARE_READ,           // share for reading 
                NULL,                      // no security 
                OPEN_EXISTING,             // existing file only 
                FILE_ATTRIBUTE_NORMAL,     // normal file 
                NULL);                     // no attr. template 


	if( filehandle == INVALID_HANDLE_VALUE )
	{
//		MessageBox( hwndmain, "Unable to open file 'hiscore.dat' ...", "Error", MB_OK|MB_ICONEXCLAMATION );
	} // end if can't find file

	else
	{
		if( !ReadFile( filehandle, &hiscore, sizeof(HISCORE), &numofbytesread, 0 ))
			MessageBox( hwndmain, "Error reading file 'hiscore.dat' ...", "Error", MB_OK|MB_ICONEXCLAMATION );

		CloseHandle( filehandle );
	}

	

// Load Boards ...
	ZeroMemory( boardsave, 8*8*40 );

	sprintf( filename, "board.dat" );

	filehandle = CreateFile( filename,           // open MYFILE.TXT 
                GENERIC_READ,              // open for reading 
                FILE_SHARE_READ,           // share for reading 
                NULL,                      // no security 
                OPEN_EXISTING,             // existing file only 
                FILE_ATTRIBUTE_NORMAL,     // normal file 
                NULL);                     // no attr. template 


	if( filehandle == INVALID_HANDLE_VALUE )
	{
		MessageBox( hwndmain, "Unable to open file 'board.dat' ...", "Error", MB_OK|MB_ICONEXCLAMATION );
		randompuzzles = 1;
	} // end if can't find file

	else
	{
		if( !ReadFile( filehandle, boardsave, 8*8*40, &numofbytesread, 0 ))
		{
			MessageBox( hwndmain, "Error reading file 'board.dat' ...", "Error", MB_OK|MB_ICONEXCLAMATION );
			randompuzzles = 1;
		}

		CloseHandle( filehandle );
	}


	srand( (unsigned)time(NULL) );


//	hPal = GetPalette();

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}


	if( randompuzzles )
	{
		CheckMenuItem( GetMenu(hwndmain), IDM_SETLEVELS, MF_UNCHECKED );
		CheckMenuItem( GetMenu(hwndmain), IDM_RANDOM, MF_CHECKED );

		ZeroMemory( &menuiteminfo, sizeof(MENUITEMINFO) );
		menuiteminfo.cbSize = sizeof(MENUITEMINFO);
		menuiteminfo.fMask = MIIM_STATE;

		GetMenuItemInfo( GetMenu(hwndmain), IDM_SETLEVELS, FALSE, &menuiteminfo );
		menuiteminfo.fState ^= MFS_GRAYED;
		SetMenuItemInfo( GetMenu(hwndmain), IDM_SETLEVELS, FALSE, &menuiteminfo );

	} // end if 'board.dat' not found


	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_LIGHTS);

	clockid = timeSetEvent( 1000/32, 0, mytimer, NULL, TIME_PERIODIC | TIME_CALLBACK_FUNCTION );
	if( clockid == NULL )
	{
		MessageBox( hwndmain, "Unable to set multimedia timer ...", "Error", MB_OK );
		releaseobjects();
		return 0;
	} // end 


	sprintf( debugstr, "starting splash screen\n" );
	WRITETODEBUGFILE;

	insplashscreen = 1;

//	openadwindow();


	if( RunMenu() == FALSE )
	{
		releaseobjects();
		return FALSE;
	} // end if failed RunMenu


// Show Splash Screen ...

/*	tempdc = CreateCompatibleDC( memdc );
	SelectPalette( tempdc, hSplashpal, FALSE );
	RealizePalette( tempdc );

	hOldPal = SelectPalette( memdc, hSplashpal, FALSE );
	SelectPalette( GetDC(hwndmain), hSplashpal, FALSE );

	SelectObject( tempdc, hbmp_splash );
	BitBlt( memdc, 0, 0, 470, 250, tempdc, 0, 0, SRCCOPY );
//	SelectPalette( tempdc, hOldPal, FALSE );
	DeleteDC( tempdc );


	tickcount = 0;
	newtickcount = tickcount + 210;
	InvalidateRect( hwndmain, 0, 0 );


	hdc = BeginPaint(hwndmain, &ps);

	RealizePalette( memdc );

	BitBlt( hdc, 0, 0, 470, 250, memdc, 0, 0, SRCCOPY );
	EndPaint(hwndmain, &ps);


	ShowWindow(hwndmain, nCmdShow);
	UpdateWindow(hwndmain);



// Splash screen message loop

	while( 1 )
	{
		if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
		{
			if( !GetMessage( &msg, NULL, 0, 0 ) )
			{
				releaseobjects();
				return msg.wParam;
			} // end if WM_QUIT received

			if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
		else
		{
			if( tickcount > newtickcount ) break;
			if( !insplashscreen ) break;	// This is changed by WM_CHAR or WM_LBUTTONDOWN
		}

	} // end splash screen message loop

*/

	centerwindow = 1;


	tickcount = 0;
	newgame(); // Ok, so I'm calling this twice ...
	tickcount = 0;


	SelectPalette( memdc, hPal, FALSE );
	SelectPalette( GetDC(hwndmain), hPal, FALSE );

	RealizePalette( memdc );


	insplashscreen = 0;


	ShowWindow(hwndmain, nCmdShow);
	UpdateWindow(hwndmain);


	SetFocus( hwndmain );


	// Main message loop:
	while( 1 )
	{
		if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
		{
			if( !GetMessage( &msg, NULL, 0, 0 ) )
			{
//				releaseobjects();
				return msg.wParam;
			} // end if WM_QUIT received

			if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
		else
		{

		if( newclock > tickcount ) goto UpdateWindow;
		

		if( wingame )
		{
			framespeed = 1;
			stopwatchon = 0;

			if( wingame == (wingame>>3)<<3 )
			{
				isfading = 7;

				goingup ^= 1;

				if( goingup )
				{
					memset( boardfade, DOWN, 8*8 ); 
				} // end if goingup
				else
				{
					memset( boardfade, UP, 8*8 ); 
				} // end if not goingup

			}

			wingame--;

			if( wingame == 0 )
			{
// TODO -- check for high score
				if( randompuzzles )
				{
					boardsaved = 0; // For randompuzzles

					if( hiscore.randmoves[difficulty-5] == 0 ) gothiscore = 1; // No hiscore yet
					if( ((int)stopwatch < hiscore.randstopwatch[difficulty-5]) &&
						(hiscore.randmoves[difficulty-5] == numberofmoves) ) gothiscore = 1;
					if( numberofmoves < hiscore.randmoves[difficulty-5] ) gothiscore = 1;

					if( gothiscore )
					{
						gothiscore = 0;
				
						hiscore.randmoves[difficulty-5] = numberofmoves;
						hiscore.randstopwatch[difficulty-5] = stopwatch;
						hiscore.randmin[difficulty-5] = minutes;
						hiscore.randsec[difficulty-5] = seconds;

//						sprintf( tempstr, "Moves:\t%d\nTime:\t%.02d:%.02d", numberofmoves, minutes, seconds );
//						MessageBox( hwndmain, tempstr, "New High Score!", MB_OK | MB_ICONEXCLAMATION );

						DialogBox(hInst, (LPCTSTR)IDD_NEWHIGH, hwndmain, (DLGPROC)newhighdialogfunc);

					} // end if gothiscore
				} // end if randompuzzles

				else
				{
					if( hiscore.setmoves[difficulty-5][boardnumber] == 0 ) gothiscore = 1; // No hiscore yet
					if( (int)stopwatch < hiscore.setstopwatch[difficulty-5][boardnumber] &&
						(hiscore.setmoves[difficulty-5][boardnumber] == numberofmoves) ) gothiscore = 1;
					if( numberofmoves < hiscore.setmoves[difficulty-5][boardnumber] ) gothiscore = 1;

					if( gothiscore )
					{
						gothiscore = 0;
				
						hiscore.setmoves[difficulty-5][boardnumber] = numberofmoves;
						hiscore.setstopwatch[difficulty-5][boardnumber] = stopwatch;
						hiscore.setmin[difficulty-5][boardnumber] = minutes;
						hiscore.setsec[difficulty-5][boardnumber] = seconds;

//						sprintf( tempstr, "Moves:\t%d\nTime:\t%.02d:%.02d", numberofmoves, minutes, seconds );
//						MessageBox( hwndmain, tempstr, "New High Score!", MB_OK | MB_ICONEXCLAMATION );

						DialogBox(hInst, (LPCTSTR)IDD_NEWHIGH, hwndmain, (DLGPROC)newhighdialogfunc);
					} // end if gothiscore

					boardnumber++;

					if( boardnumber == 10 )
					{
						boardnumber = 0;
						difficulty++;

						CheckMenuItem( GetMenu(hwndmain), IDM_EASY, MF_UNCHECKED );
						CheckMenuItem( GetMenu(hwndmain), IDM_MEDIUM, MF_UNCHECKED );
						CheckMenuItem( GetMenu(hwndmain), IDM_HARD, MF_UNCHECKED );
						CheckMenuItem( GetMenu(hwndmain), IDM_GENIUS, MF_UNCHECKED );

						switch( difficulty )
						{
						case EASY:
							CheckMenuItem( GetMenu(hwndmain), IDM_EASY, MF_CHECKED );
							break;
						case MEDIUM:
							CheckMenuItem( GetMenu(hwndmain), IDM_MEDIUM, MF_CHECKED );
							break;
						case HARD:
							CheckMenuItem( GetMenu(hwndmain), IDM_HARD, MF_CHECKED );
							break;
						case GENIUS:
							CheckMenuItem( GetMenu(hwndmain), IDM_GENIUS, MF_CHECKED );
							break;

						case GENIUS+1:
							DialogBox(hInst, (LPCTSTR)IDD_HISCORES, hwndmain, (DLGPROC)hiscoredialogfunc);

							difficulty = EASY;
							randompuzzles = 1;

							CheckMenuItem( GetMenu(hwndmain), IDM_SETLEVELS, MF_UNCHECKED );
							CheckMenuItem( GetMenu(hwndmain), IDM_RANDOM, MF_CHECKED );

							CheckMenuItem( GetMenu(hwndmain), IDM_EASY, MF_CHECKED );
							break; // if beat ALL levels

						}


					} // end if beat all boards of this difficulty

				} // end if setlevels

// Save high scores ...
			filehandle = CreateFile("hiscore.dat",           // create MYFILE.TXT 
             GENERIC_WRITE,                // open for writing 
             0,                            // do not share 
             NULL,                         // no security 
             CREATE_ALWAYS,                // overwrite existing 
             FILE_ATTRIBUTE_NORMAL |       // normal file 
             FILE_FLAG_SEQUENTIAL_SCAN,         // asynchronous I/O 
             NULL);                        // no attr. template 

			if( filehandle == INVALID_HANDLE_VALUE )
				MessageBox( hwndmain, "Unable to save high scores ...", "Error!", MB_OK|MB_ICONEXCLAMATION );
			else
			{
				WriteFile( filehandle, &hiscore, sizeof(HISCORE), &numofbytesread, NULL );
				CloseHandle( filehandle );
			}



				newgame();
				framespeed = 1;
			} // end if won the game

			updatingwindow = 1;
		} // end if wingame


		if( isfading )
		{
			if( newclock <= tickcount )
			{
				newclock = tickcount + framespeed;

			isfading--;

			for( slotno = 0; slotno < difficulty*difficulty; slotno++ )
			{
				switch( boardfade[slotno] )
				{
				default:
					break;

				case UP:
					board[slotno] = 7-isfading;
					break;
				case DOWN:
					board[slotno] = isfading;
					break;

				} // end switch on boardfade

			} // end slotno loop


			if( (isfading == 0) && (!wingame) )
			{
				HDC tempdc;


				resetpushed = 0;

				tempdc = CreateCompatibleDC( memdc );
hOldPal = SelectPalette( tempdc, hPal, FALSE );
RealizePalette( tempdc );

				SelectObject( tempdc, hbmp_reset[0] );
				BitBlt( memdc, resetx, resety, 80, 35, tempdc, 0, 0, SRCCOPY );
SelectPalette( tempdc, hOldPal, FALSE );
				DeleteDC( tempdc );
	
				nextpushed = 0;

				tempdc = CreateCompatibleDC( memdc );
hOldPal = SelectPalette( tempdc, hPal, FALSE );
RealizePalette( tempdc );

				SelectObject( tempdc, hbmp_next[0] );
				BitBlt( memdc, nextx, nexty, 80, 35, tempdc, 0, 0, SRCCOPY );
SelectPalette( tempdc, hOldPal, FALSE );
				DeleteDC( tempdc );
	


				ZeroMemory( boardfade, 8*8 );

				for( slotno = 0; slotno < difficulty*difficulty; slotno++ )
				{
					if( board[slotno] == 7 ) break;
				} // end check for win game

				if( slotno == difficulty*difficulty )
				{
					wingame = 8*8;
					goingup = 1;

					if( soundon )
					{
						PlaySound( "SND_WIN", GetModuleHandle(NULL), SND_RESOURCE|SND_ASYNC );
					}
				} 
			}

			updatingwindow = 1;

			} // end if time to fade

		} // end if isfading 

UpdateWindow:

		if( updatingwindow )
		{
			updatingwindow = 0;
			drawboard();
//			updatewindow();
		} // end if updatingwindow

		if( drawingstopwatch )
		{
			drawingstopwatch = 0;
			drawstopwatch();
		} // end if drawingstopwatch


		}



	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_LIGHTS);
	wcex.hCursor		= NULL;
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_LIGHTS;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}


ATOM MenuRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)SplashWndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_LIGHTS);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= "MenuWindowClass";
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}



//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;
   RECT rect;
   POINT point;

   HDC tempdc, hdc;

   hInst = hInstance; // Store instance handle in our global variable


   hWnd = CreateWindow( szWindowClass, szTitle, windowstyle,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   hwndmain = hWnd;

   if (!hWnd)
   {
      return FALSE;
   }

// Load Cursors ...
   hcursor[0] = LoadCursor( NULL, IDC_ARROW );
   hcursor[1] = LoadCursor( hInstance, "HANDCURSOR" );


// Load Bitmaps ...

// Interfaces ...
   hbmp_interface[0] = LoadResourceBitmap( hInst, "INTERFACE_0", &hPal );
   hbmp_interface[1] = LoadResourceBitmap( hInst, "INTERFACE_1", &hPal );
   hbmp_interface[2] = LoadResourceBitmap( hInst, "INTERFACE_2", &hPal );
   hbmp_interface[3] = LoadResourceBitmap( hInst, "INTERFACE_3", &hPal );

   hbmp_rs[0] = LoadResourceBitmap( hInst, "RS_0", &hPal );
   hbmp_rs[1] = LoadResourceBitmap( hInst, "RS_1", &hPal );
   hbmp_rs[2] = LoadResourceBitmap( hInst, "RS_2", &hPal );
   hbmp_rs[3] = LoadResourceBitmap( hInst, "RS_3", &hPal );

   hbmp_edge = LoadResourceBitmap( hInst, "EDGE", &hPal );



// Reset Buttons ...
   hbmp_reset[0] = LoadResourceBitmap( hInst, "RESET1", &hPal );
   hbmp_reset[1] = LoadResourceBitmap( hInst, "RESET2", &hPal );

// Reset Buttons ...
   hbmp_next[0] = LoadResourceBitmap( hInst, "NEXT0", &hPal );
   hbmp_next[1] = LoadResourceBitmap( hInst, "NEXT1", &hPal );

// Lights ...
   hbmp_light[0] = LoadResourceBitmap( hInst, "LIGHT7", &hPal );
   hbmp_light[1] = LoadResourceBitmap( hInst, "LIGHT6", &hPal );
   hbmp_light[2] = LoadResourceBitmap( hInst, "LIGHT5", &hPal );
   hbmp_light[3] = LoadResourceBitmap( hInst, "LIGHT4", &hPal );
   hbmp_light[4] = LoadResourceBitmap( hInst, "LIGHT3", &hPal );
   hbmp_light[5] = LoadResourceBitmap( hInst, "LIGHT2", &hPal );
   hbmp_light[6] = LoadResourceBitmap( hInst, "LIGHT1", &hPal );
   hbmp_light[7] = LoadResourceBitmap( hInst, "LIGHT0", &hPal );

// Numbers ...
   hbmp_digit[0] = LoadResourceBitmap( hInst, "DIGIT0", &hPal );
   hbmp_digit[1] = LoadResourceBitmap( hInst, "DIGIT1", &hPal );
   hbmp_digit[2] = LoadResourceBitmap( hInst, "DIGIT2", &hPal );
   hbmp_digit[3] = LoadResourceBitmap( hInst, "DIGIT3", &hPal );
   hbmp_digit[4] = LoadResourceBitmap( hInst, "DIGIT4", &hPal );
   hbmp_digit[5] = LoadResourceBitmap( hInst, "DIGIT5", &hPal );
   hbmp_digit[6] = LoadResourceBitmap( hInst, "DIGIT6", &hPal );
   hbmp_digit[7] = LoadResourceBitmap( hInst, "DIGIT7", &hPal );
   hbmp_digit[8] = LoadResourceBitmap( hInst, "DIGIT8", &hPal );
   hbmp_digit[9] = LoadResourceBitmap( hInst, "DIGIT9", &hPal );
   hbmp_digit[10] = LoadResourceBitmap( hInst, "DIGIT10", &hPal );


// Splash bitmaps ...
   hbmp_letter[0] = LoadResourceBitmap( hInst, "B", &hSplashPal );
   hbmp_letter[1] = LoadResourceBitmap( hInst, "L", &hSplashPal );
   hbmp_letter[2] = LoadResourceBitmap( hInst, "I", &hSplashPal );
   hbmp_letter[3] = LoadResourceBitmap( hInst, "N", &hSplashPal );
   hbmp_letter[4] = LoadResourceBitmap( hInst, "K", &hSplashPal );
   hbmp_letter[5] = LoadResourceBitmap( hInst, "I2", &hSplashPal );
   hbmp_letter[6] = LoadResourceBitmap( hInst, "N2", &hSplashPal );
   hbmp_letter[7] = LoadResourceBitmap( hInst, "APOS", &hSplashPal );

   hbmp_splash[0] = LoadResourceBitmap( hInst, "INSTRUCTIONS", &hSplashPal );
   hbmp_splash[1] = LoadResourceBitmap( hInst, "PLAY", &hSplashPal );
   hbmp_splash[2] = LoadResourceBitmap( hInst, "NSPLOGO", &hSplashPal );
//   hbmp_splash[3] = LoadResourceBitmap( hInst, "CYDOORLOGO", &hSplashPal );
   hbmp_splash[4] = LoadResourceBitmap( hInst, "INSTRUCTIONS2", &hSplashPal );
   hbmp_splash[5] = LoadResourceBitmap( hInst, "PLAYNOW", &hSplashPal );
   hbmp_splash[6] = LoadResourceBitmap( hInst, "NSPTEXT", &hSplashPal );
//   hbmp_splash[7] = LoadResourceBitmap( hInst, "CYDOORTEXT", &hSplashPal );



// Create virtual window ... make max size of (400+INTERFACEWIDTH) by 400;
	hdc = GetDC( hwndmain );
hOldPal = SelectPalette( hdc, hPal, FALSE );
RealizePalette( hdc );
	memdc = CreateCompatibleDC( hdc );
hOldPal = SelectPalette( hdc, hPal, FALSE );
RealizePalette( hdc );

	hbmp_vs = CreateCompatibleBitmap( hdc, 400+INTERFACEWIDTH+RSWIDTH, 400 );
	SelectObject( memdc, hbmp_vs );

	ReleaseDC( hwndmain, hdc );



//   wingame = (8*4);
//   goingup = 1;

// Set Window Size ...

/*   screenmaxx = GetSystemMetrics( SM_CXSCREEN );
   screenmaxy = GetSystemMetrics( SM_CYSCREEN );
*/

	SystemParametersInfo( SPI_GETWORKAREA, NULL, &rect, NULL );
	screenmaxx = rect.right;
	screenmaxy = rect.bottom;



	GetCursorPos( &point );


	rect.top = 0;
	rect.bottom = (32*difficulty);
	rect.left = 0;
	rect.right =  (32*difficulty) + INTERFACEWIDTH+RSWIDTH;

	AdjustWindowRect( &rect, windowstyle, TRUE );

	rect.bottom -= rect.top;
	rect.top = 0;
	rect.right -= rect.left;
	rect.left = 0;

/*	rect.left = point.x - 64;
	rect.top = point.y - 224;
*/
	// Center window ...
	rect.left = (screenmaxx/2) - (rect.right/2);
	rect.top = (screenmaxy/2) - (rect.bottom/2);

	if( rect.left < 0 ) rect.left = 0;
	if( rect.left+rect.right > screenmaxx ) rect.left = screenmaxx-rect.right;
	if( rect.top < 0 ) rect.top = 0;
	if( rect.top+rect.bottom > screenmaxy ) rect.top = screenmaxy-rect.bottom;

	SetWindowPos( hwndmain, HWND_TOP, rect.left, rect.top, rect.right, rect.bottom, NULL );


	tempdc = CreateCompatibleDC( memdc );
hOldPal = SelectPalette( tempdc, hPal, FALSE );
RealizePalette( tempdc );

	SelectObject( tempdc, hbmp_interface[difficulty-5] );
	BitBlt( memdc, 0, 0, 120, difficulty*32, tempdc, 0, 0, SRCCOPY );
SelectPalette( tempdc, hOldPal, FALSE );
	DeleteDC( tempdc );
	
	tempdc = CreateCompatibleDC( memdc );
hOldPal = SelectPalette( tempdc, hPal, FALSE );
RealizePalette( tempdc );

	SelectObject( tempdc, hbmp_rs[difficulty-5] );
	BitBlt( memdc, INTERFACEWIDTH+difficulty*32, 0, 120, difficulty*32, tempdc, 0, 0, SRCCOPY );
SelectPalette( tempdc, hOldPal, FALSE );
	DeleteDC( tempdc );

	// Draw edge ...
	tempdc = CreateCompatibleDC( memdc );
hOldPal = SelectPalette( tempdc, hPal, FALSE );
RealizePalette( tempdc );

	SelectObject( tempdc, hbmp_edge );
	for( int row = 0; row < difficulty; row++ )
	{
		BitBlt( memdc, INTERFACEWIDTH+(row*32), 0, 32, 20, tempdc, 0, 0, SRCCOPY );
		BitBlt( memdc, INTERFACEWIDTH+(row*32), (difficulty*32)+20, 32, 20, tempdc, 0, 0, SRCCOPY );
	} // end draw each row
SelectPalette( tempdc, hOldPal, FALSE );
	DeleteDC( tempdc );



	tempdc = CreateCompatibleDC( memdc );
hOldPal = SelectPalette( tempdc, hPal, FALSE );
RealizePalette( tempdc );

	SelectObject( tempdc, hbmp_reset[0] );
	BitBlt( memdc, resetx, resety, 80, 35, tempdc, 0, 0, SRCCOPY );
SelectPalette( tempdc, hOldPal, FALSE );
	DeleteDC( tempdc );
	
	tempdc = CreateCompatibleDC( memdc );
hOldPal = SelectPalette( tempdc, hPal, FALSE );
RealizePalette( tempdc );

	SelectObject( tempdc, hbmp_next[0] );
	BitBlt( memdc, nextx, nexty, 80, 35, tempdc, 0, 0, SRCCOPY );
SelectPalette( tempdc, hOldPal, FALSE );
	DeleteDC( tempdc );


	

   newgame();
	
//	drawboard();




/*
	hdc = GetDC( hwndmain );
	SetSystemPaletteUse( hdc, SYSPAL_STATIC );
	hPal = GetPalette();

	tempdc = CreateCompatibleDC( memdc );
	SelectObject( tempdc, hbmp_interface[difficulty-5] );

	SelectPalette( memdc, hPal, FALSE );
    RealizePalette( memdc );
	SelectPalette( hdc, hPal, FALSE );
    RealizePalette( hdc );
	DeleteObject( hPal );

	BitBlt( memdc, 0, 0, 120, difficulty*50, tempdc, 0, 0, SRCCOPY );
	ReleaseDC( hwndmain, hdc );

	DeleteDC( tempdc );
*/



   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;

	int slotno, tempslotno;
	int slotx, sloty;

	int index, cursorx, cursory;

	int wmId, wmEvent;
	PAINTSTRUCT ps;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);

	switch (message) 
	{
		case WM_DISPLAYCHANGE:
			RECT rect, oldrect;
			int windowheight;


			SystemParametersInfo( SPI_GETWORKAREA, NULL, &rect, NULL );
			screenmaxx = rect.right;
			screenmaxy = rect.bottom;

			// Center windows ...
			// Set Window Size ...
			if( inmenu )
			{
				GetWindowRect( hwndmenu, &oldrect );

				rect.top = 0;
				rect.bottom = 240;

				rect.left = 0;
				rect.right = 400;
		
				AdjustWindowRect( &rect, WS_DLGFRAME|WS_SYSMENU|WS_CAPTION, FALSE );

			} // end if inmenu
			else
			{
				GetWindowRect( hwndmain, &oldrect );

				rect.top = 0;
				rect.bottom = (32*difficulty) + 40;
	
				rect.left = 0;
				rect.right =  (32*difficulty) + INTERFACEWIDTH+RSWIDTH;
			
				AdjustWindowRect( &rect, windowstyle, TRUE );
	
			}
	
		
			rect.bottom -= rect.top;
			rect.top = 0;
			rect.right -= rect.left;
			rect.left = 0;
		
			rect.left = (screenmaxx/2) - (rect.right/2);
			rect.top = (screenmaxy/2) - (rect.bottom/2);

		

//			break;
/*
		case WM_ACTIVATEAPP:
			if( wParam == TRUE )
			{
				SelectPalette( memdc, hPal, FALSE );
				RealizePalette( memdc );
				updatingwindow = 1;
			}
			break;
*/
		case WM_ACTIVATE:
		case WM_QUERYNEWPALETTE:
			hOldPal = SelectPalette( memdc, hPal, FALSE );
			RealizePalette( memdc );

			if( inmenu )
			{
				hdc = GetDC( hwndmenu );
				hOldPal = SelectPalette( hdc, hPal, FALSE );
				RealizePalette( hdc );
//			UpdateColors( hdc );
				ReleaseDC( hwndmenu, hdc );

				RealizePalette( memdc );
//			UpdateColors( memdc );
				DrawSplash();

				InvalidateRect( hwndmenu, NULL, FALSE );
			}
			else
			{
				hdc = GetDC( hwndmain );
				hOldPal = SelectPalette( hdc, hPal, FALSE );
				RealizePalette( hdc );
//			UpdateColors( hdc );
				ReleaseDC( hwndmain, hdc );

				RealizePalette( memdc );
//			UpdateColors( memdc );

				InvalidateRect( hwndmain, NULL, FALSE );
			} // end if !inmenu

			break;

		case WM_PALETTEISCHANGING:
			RECT Rect;
			HDC hDC;

            if (wParam != (UINT)hWnd) { 
                GetClientRect(hWnd, &Rect); 
 
                hDC = GetDC(hWnd); 
                FillRect( hDC, &Rect, (HBRUSH)GetStockObject(BLACK_BRUSH)); 
                ReleaseDC(hWnd, hDC); 

                FillRect( memdc, &Rect, (HBRUSH)GetStockObject(BLACK_BRUSH)); 

				InvalidateRect( hwndmain, NULL, TRUE );
				if( !inmenu ) drawboard();
				else DrawSplash();
            }
            break; 



		case WM_PALETTECHANGED:
			if( (HWND)wParam != hwndmain )
			{
				hOldPal = SelectPalette( memdc, hPal, TRUE );
				RealizePalette( memdc );
//				UpdateColors( memdc );

				hdc = GetDC( hwndmain );
				hOldPal = SelectPalette( hdc, hPal, TRUE );
				RealizePalette( hdc );
//				UpdateColors( hdc );

				ReleaseDC( hwndmain, hdc );
				InvalidateRect( hwndmain, NULL, TRUE );

				if( !inmenu ) drawboard();
				else DrawSplash();
			}
			break;


		case WM_COMMAND:
			if( insplashscreen ) break;


			wmId    = LOWORD(wParam);
			wmEvent = HIWORD(wParam);
			// Parse the menu selections:
			switch (wmId)
			{
				case ID_DOWNLOADNSP:
					ShellExecute( hwndmain, "open", "http://www.nspgames.com", NULL, NULL, 0 );
					break;

//				case ID_DOWNLOADCYDOOR:
//					ShellExecute( hwndmain, "open", "http://www.cydoor.com", NULL, NULL, 0 );
//					break;

				case IDM_HELP:
					WinHelp( hwndmain, "Blinkin.hlp", HELP_CONTEXT, 1 );
					break;

#ifdef SHAREWARE
				case IDM_ORDER:
					WinExec( "notepad order.txt", SW_SHOW );
					break;
#endif

				case IDM_SOUND:
					soundon ^= 1;
					if( soundon )
						CheckMenuItem( GetMenu(hwndmain), IDM_SOUND, MF_CHECKED );
					else
						CheckMenuItem( GetMenu(hwndmain), IDM_SOUND, MF_UNCHECKED );

					break;

				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_HISCORE:
				   DialogBox(hInst, (LPCTSTR)IDD_HISCORES, hWnd, (DLGPROC)hiscoredialogfunc);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;

				case IDM_NEWGAME:
					boardnumber = 0;
					boardsaved = 0; // For randompuzzles
					newgame();
					break;

				case IDM_EASY:
					if( difficulty == EASY ) break;
					difficulty = EASY;
					boardnumber = 0;
					CheckMenuItem( GetMenu(hwndmain), IDM_EASY, MF_CHECKED );
					CheckMenuItem( GetMenu(hwndmain), IDM_MEDIUM, MF_UNCHECKED );
					CheckMenuItem( GetMenu(hwndmain), IDM_HARD, MF_UNCHECKED );
					CheckMenuItem( GetMenu(hwndmain), IDM_GENIUS, MF_UNCHECKED );

					boardsaved = 0; // For randompuzzles

					centerwindow = 1;
					newgame();
					break;
				case IDM_MEDIUM:
#ifdef SHAREWARE
					DialogBox( hInst, (LPCSTR)IDD_SHAREWARE, hWnd, (DLGPROC)sharewaredialogfunc);
					break;
#endif
					if( difficulty == MEDIUM ) break;
					difficulty = MEDIUM;
					boardnumber = 0;
					CheckMenuItem( GetMenu(hwndmain), IDM_EASY, MF_UNCHECKED );
					CheckMenuItem( GetMenu(hwndmain), IDM_MEDIUM, MF_CHECKED );
					CheckMenuItem( GetMenu(hwndmain), IDM_HARD, MF_UNCHECKED );
					CheckMenuItem( GetMenu(hwndmain), IDM_GENIUS, MF_UNCHECKED );

					boardsaved = 0; // For randompuzzles
					centerwindow = 1;
					newgame();
					break;
				case IDM_HARD:
#ifdef SHAREWARE
					DialogBox( hInst, (LPCSTR)IDD_SHAREWARE, hWnd, (DLGPROC)sharewaredialogfunc);
					break;
#endif
					if( difficulty == HARD ) break;

					difficulty = HARD;
					boardnumber = 0;
					CheckMenuItem( GetMenu(hwndmain), IDM_EASY, MF_UNCHECKED );
					CheckMenuItem( GetMenu(hwndmain), IDM_MEDIUM, MF_UNCHECKED );
					CheckMenuItem( GetMenu(hwndmain), IDM_HARD, MF_CHECKED );
					CheckMenuItem( GetMenu(hwndmain), IDM_GENIUS, MF_UNCHECKED );

					boardsaved = 0; // For randompuzzles
					centerwindow = 1;
					newgame();
					break;
				case IDM_GENIUS:
#ifdef SHAREWARE
					DialogBox( hInst, (LPCSTR)IDD_SHAREWARE, hWnd, (DLGPROC)sharewaredialogfunc);
					break;
#endif
					if( difficulty == GENIUS ) break;

					difficulty = GENIUS;
					boardnumber = 0;
					CheckMenuItem( GetMenu(hwndmain), IDM_EASY, MF_UNCHECKED );
					CheckMenuItem( GetMenu(hwndmain), IDM_MEDIUM, MF_UNCHECKED );
					CheckMenuItem( GetMenu(hwndmain), IDM_HARD, MF_UNCHECKED );
					CheckMenuItem( GetMenu(hwndmain), IDM_GENIUS, MF_CHECKED );

					boardsaved = 0; // For randompuzzles
					centerwindow = 1;
					newgame();
					break;

				case IDM_RANDOM:
#ifdef SHAREWARE
					DialogBox( hInst, (LPCSTR)IDD_SHAREWARE, hWnd, (DLGPROC)sharewaredialogfunc);
					break;
#endif
					if( randompuzzles ) break;
					boardnumber = 0;
					randompuzzles = 1;
					CheckMenuItem( GetMenu(hwndmain), IDM_SETLEVELS, MF_UNCHECKED );
					CheckMenuItem( GetMenu(hwndmain), IDM_RANDOM, MF_CHECKED );
					boardsaved = 0; // For randompuzzles
					newgame();
					break;

				case IDM_SETLEVELS:
					if( !randompuzzles ) break;
					boardnumber = 0;
					randompuzzles = 0;
					CheckMenuItem( GetMenu(hwndmain), IDM_SETLEVELS, MF_CHECKED );
					CheckMenuItem( GetMenu(hwndmain), IDM_RANDOM, MF_UNCHECKED );
					boardsaved = 0; // For randompuzzles
					newgame();
					break;

#ifdef EDITORS
				case IDM_SAVEAS1:
				case IDM_SAVEAS2:
				case IDM_SAVEAS3:
				case IDM_SAVEAS4:
				case IDM_SAVEAS5:
				case IDM_SAVEAS6:
				case IDM_SAVEAS7:
				case IDM_SAVEAS8:
				case IDM_SAVEAS9:
				case IDM_SAVEAS10:
					wmId -= 32782L;	// value of IDM_SAVEAS1

// Save boards ...
					memcpy( boardsave + ((difficulty-5)*10*64)+(wmId*64), board, 64 );

					filehandle = CreateFile("board.dat",           // create MYFILE.TXT 
				     GENERIC_WRITE,                // open for writing 
		             0,                            // do not share 
				     NULL,                         // no security 
		             CREATE_ALWAYS,                // overwrite existing 
				     FILE_ATTRIBUTE_NORMAL |       // normal file 
		             FILE_FLAG_SEQUENTIAL_SCAN,         // asynchronous I/O 
				     NULL);                        // no attr. template 

					if( filehandle == INVALID_HANDLE_VALUE )
						MessageBox( hwndmain, "Unable to save boards ...", "Error!", MB_OK|MB_ICONEXCLAMATION );
					else
					{
						WriteFile( filehandle, boardsave, 8*8*40, &numofbytesread, NULL );
						CloseHandle( filehandle );
					}

					break;
#endif

				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;

		case WM_CHAR:
			if( insplashscreen )
			{
				insplashscreen = 0;
				break;
			}


			switch( wParam )
			{
#ifdef EDITORS
			case 'n':
				boardnumber++;
				if( boardnumber == 10 ) boardnumber = 0;
				boardsaved = 0; // For randompuzzles
				newgame();
				break;

			case 'r':
				result = RealizePalette( memdc );
				sprintf( tempstr, "%d colors realized.", result );
				MessageBox( hwndmain, tempstr, "RealizePalette()", MB_OK );

				UpdateColors( memdc );
				hdc = GetDC(hwndmain);

				UpdateColors( memdc );
				ReleaseDC( hwndmain, hdc );

				drawboard();
				break;
#endif

			} // end switch on key pressed

			break;


		case WM_MOUSEMOVE:
			cursorx = LOWORD(lParam);
			cursory = HIWORD(lParam);

			// Check mouseovers ...
			for( index = 0; index < 3; index++ )
			{
				if( cursorx < splashrect[index].left ) continue;
				if( cursorx > splashrect[index].right ) continue;
				if( cursory < splashrect[index].top ) continue;
				if( cursory > splashrect[index].bottom ) continue;

				break;
			} // end loop through rectangles

			mouseover = index;

/*			if( mouseover != oldmouseover )
			{
				DrawSplash();
				InvalidateRect( hwndmenu, NULL, FALSE );

				oldmouseover = mouseover;
			} // end if new mouseover
*/
			if( mouseover < 3 )
			{
				SetCursor( hcursor[1] );
			}
			else
			{
				SetCursor( hcursor[0] );
			}



			break;

		case WM_LBUTTONDOWN:
			if( insplashscreen )
			{
				insplashscreen = 0;
				break;

			} // end if insplashscreen

			if( isfading ) break; // Can't do anything while fading ...


// Check for reset click ...
			if( (LOWORD(lParam) > resetx) && (LOWORD(lParam) < resetx+80) &&
				(HIWORD(lParam) > resety) && (HIWORD(lParam) < resety+35) )
			{
				resetpushed = 1;

				newgame();

				if( soundon )
				{
					PlaySound( "SND_RESET", GetModuleHandle(NULL), SND_RESOURCE|SND_ASYNC );
				}

				break;
			} // end if reset pushed

// Check for next click ...
			if( (LOWORD(lParam) > nextx) && (LOWORD(lParam) < nextx+80) &&
				(HIWORD(lParam) > nexty) && (HIWORD(lParam) < nexty+35) )
			{
				nextpushed = 1;

				boardnumber++;
				if( boardnumber == 10 ) boardnumber = 0;

				boardsaved = 0; // For randompuzzles

				newgame();

				if( soundon )
				{
					PlaySound( "SND_RESET", GetModuleHandle(NULL), SND_RESOURCE|SND_ASYNC );
				}

				break;
			} // end if next pushed



// Check for board click ...
			if( (LOWORD(lParam) >= INTERFACEWIDTH) && (LOWORD(lParam) < clientwidth-RSWIDTH) &&
				(HIWORD(lParam) > 20) && (HIWORD(lParam) < clientheight-20) )
			{

				if( soundon )
				{
					PlaySound( "SND_BLIP", GetModuleHandle(NULL), SND_RESOURCE|SND_ASYNC );
				}

				stopwatchon = 1;

				numberofmoves++;

				if( numberofmoves == 1000 ) numberofmoves--;

				drawnumberofmoves();


				slotx = (LOWORD(lParam) - INTERFACEWIDTH) / 32;
				sloty = (HIWORD(lParam)-20) / 32;
				slotno = (sloty*difficulty) + slotx;

// TODO -- Change to fading ...
				if( board[slotno] ) boardfade[slotno] = DOWN;
				else boardfade[slotno] = UP;

// Do surrounding spaces ...
				if( slotx > 0 )
				{
					tempslotno = slotno-1;
					if( board[tempslotno] ) boardfade[tempslotno] = DOWN;
					else boardfade[tempslotno] = UP;
				} // end if valid slot

				if( slotx < difficulty-1 )
				{
					tempslotno = slotno+1;
					if( board[tempslotno] ) boardfade[tempslotno] = DOWN;
					else boardfade[tempslotno] = UP;
				} // end if valid slot


				if( sloty > 0 )
				{
					tempslotno = slotno-difficulty;
					if( board[tempslotno] ) boardfade[tempslotno] = DOWN;
					else boardfade[tempslotno] = UP;
				} // end if valid slot

				if( sloty < difficulty-1 )
				{
					tempslotno = slotno+difficulty;
					if( board[tempslotno] ) boardfade[tempslotno] = DOWN;
					else boardfade[tempslotno] = UP;
				} // end if valid slot

				isfading = 7;

				break;

			} // end if clicked on board


			break; // end WM_LBUTTONDOWN


#ifdef EDITORS
		case WM_RBUTTONDOWN:
			if( insplashscreen ) break;


// Check for board click ...
			if( (LOWORD(lParam) >= INTERFACEWIDTH) && (LOWORD(lParam) < clientwidth-RSWIDTH) )
			{
				slotx = (LOWORD(lParam) - INTERFACEWIDTH) / 32;
				sloty = HIWORD(lParam) / 32;
				slotno = (sloty*difficulty) + slotx;

				if( board[slotno] ) board[slotno] = 0;
				else board[slotno] = 7;

				updatingwindow = 1;

			} // end if clicked on board


			break; // end WM_RBUTTONDOWN
#endif



		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...

			RealizePalette( memdc );

			BitBlt( hdc, 0, 0, clientwidth, clientheight, memdc, 0, 0, SRCCOPY );
			EndPaint(hWnd, &ps);
			break;


		case WM_CREATE:
			break;

		case WM_DESTROY:
			releaseobjects();
			timeKillEvent( clockid );

			PostQuitMessage(0);
			break;


		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}



// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
			SetDlgItemText( hDlg, IDC_BLURB, "This version of Blinkin' has been brought to you free by NSP Games (nspgames.com). Please support free software ... visit gnu.org for info!" );
			return TRUE;

		case WM_COMMAND:
			switch( LOWORD(wParam) )
			{
			case IDOK:
			case IDCANCEL:
				EndDialog( hDlg, LOWORD(wParam) );
				return TRUE;

/*			case IDC_WEBPAGEBUTTON:
				ShellExecute( hwndmain, "open", "http://www.nspgames.com", NULL, NULL, 0 );
				break;

			case IDC_WEBPAGEBUTTON2:
				ShellExecute( hwndmain, "open", "http://www.cydoor.com", NULL, NULL, 0 );
				break;
*/
			} // end switch on which command

			break;

	}
    return FALSE;
}


// Mesage handler for shareware box.
LRESULT CALLBACK sharewaredialogfunc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}




// Mesage handler for new high score box.
LRESULT CALLBACK newhighdialogfunc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
			sprintf( tempstr, "Moves - %d", numberofmoves );
			SetDlgItemText( hDlg, IDC_MOVES, tempstr );
			sprintf( tempstr, "Time - %.2d:%.2d", minutes, seconds );
			SetDlgItemText( hDlg, IDC_TIME, tempstr );

				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}




LRESULT CALLBACK hiscoredialogfunc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:

ShowHighScores:
// Show Set Puzzle Scores ...
			if( hiscore.setmoves[0][0] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[0][0], hiscore.setmin[0][0], hiscore.setsec[0][0] );
			SetDlgItemText( hDlg, IDC_EASY1, tempstr );

			if( hiscore.setmoves[1][0] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[1][0], hiscore.setmin[1][0], hiscore.setsec[1][0] );
			SetDlgItemText( hDlg, IDC_MEDIUM1, tempstr );

			if( hiscore.setmoves[2][0] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[2][0], hiscore.setmin[2][0], hiscore.setsec[2][0] );
			SetDlgItemText( hDlg, IDC_HARD1, tempstr );

			if( hiscore.setmoves[3][0] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[3][0], hiscore.setmin[3][0], hiscore.setsec[3][0] );
			SetDlgItemText( hDlg, IDC_GENIUS1, tempstr );


			if( hiscore.setmoves[0][1] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[0][1], hiscore.setmin[0][1], hiscore.setsec[0][1] );
			SetDlgItemText( hDlg, IDC_EASY2, tempstr );

			if( hiscore.setmoves[1][1] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[1][1], hiscore.setmin[1][1], hiscore.setsec[1][1] );
			SetDlgItemText( hDlg, IDC_MEDIUM2, tempstr );

			if( hiscore.setmoves[2][1] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[2][1], hiscore.setmin[2][1], hiscore.setsec[2][1] );
			SetDlgItemText( hDlg, IDC_HARD2, tempstr );

			if( hiscore.setmoves[3][1] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[3][1], hiscore.setmin[3][1], hiscore.setsec[3][1] );
			SetDlgItemText( hDlg, IDC_GENIUS2, tempstr );


			if( hiscore.setmoves[0][2] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[0][2], hiscore.setmin[0][2], hiscore.setsec[0][2] );
			SetDlgItemText( hDlg, IDC_EASY3, tempstr );

			if( hiscore.setmoves[1][2] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[1][2], hiscore.setmin[1][2], hiscore.setsec[1][2] );
			SetDlgItemText( hDlg, IDC_MEDIUM3, tempstr );

			if( hiscore.setmoves[2][2] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[2][2], hiscore.setmin[2][2], hiscore.setsec[2][2] );
			SetDlgItemText( hDlg, IDC_HARD3, tempstr );

			if( hiscore.setmoves[3][2] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[3][2], hiscore.setmin[3][2], hiscore.setsec[3][2] );
			SetDlgItemText( hDlg, IDC_GENIUS3, tempstr );


			if( hiscore.setmoves[0][3] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[0][3], hiscore.setmin[0][3], hiscore.setsec[0][3] );
			SetDlgItemText( hDlg, IDC_EASY4, tempstr );

			if( hiscore.setmoves[1][3] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[1][3], hiscore.setmin[1][3], hiscore.setsec[1][3] );
			SetDlgItemText( hDlg, IDC_MEDIUM4, tempstr );

			if( hiscore.setmoves[2][3] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[2][3], hiscore.setmin[2][3], hiscore.setsec[2][3] );
			SetDlgItemText( hDlg, IDC_HARD4, tempstr );

			if( hiscore.setmoves[3][3] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[3][3], hiscore.setmin[3][3], hiscore.setsec[3][3] );
			SetDlgItemText( hDlg, IDC_GENIUS4, tempstr );


			if( hiscore.setmoves[0][4] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[0][4], hiscore.setmin[0][4], hiscore.setsec[0][4] );
			SetDlgItemText( hDlg, IDC_EASY5, tempstr );

			if( hiscore.setmoves[1][4] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[1][4], hiscore.setmin[1][4], hiscore.setsec[1][4] );
			SetDlgItemText( hDlg, IDC_MEDIUM5, tempstr );

			if( hiscore.setmoves[2][4] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[2][4], hiscore.setmin[2][4], hiscore.setsec[2][4] );
			SetDlgItemText( hDlg, IDC_HARD5, tempstr );

			if( hiscore.setmoves[3][4] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[3][4], hiscore.setmin[3][4], hiscore.setsec[3][4] );
			SetDlgItemText( hDlg, IDC_GENIUS5, tempstr );


			if( hiscore.setmoves[0][5] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[0][5], hiscore.setmin[0][5], hiscore.setsec[0][5] );
			SetDlgItemText( hDlg, IDC_EASY6, tempstr );

			if( hiscore.setmoves[1][5] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[1][5], hiscore.setmin[1][5], hiscore.setsec[1][5] );
			SetDlgItemText( hDlg, IDC_MEDIUM6, tempstr );

			if( hiscore.setmoves[2][5] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[2][5], hiscore.setmin[2][5], hiscore.setsec[2][5] );
			SetDlgItemText( hDlg, IDC_HARD6, tempstr );

			if( hiscore.setmoves[3][5] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[3][5], hiscore.setmin[3][5], hiscore.setsec[3][5] );
			SetDlgItemText( hDlg, IDC_GENIUS6, tempstr );


			if( hiscore.setmoves[0][6] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[0][6], hiscore.setmin[0][6], hiscore.setsec[0][6] );
			SetDlgItemText( hDlg, IDC_EASY7, tempstr );

			if( hiscore.setmoves[1][6] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[1][6], hiscore.setmin[1][6], hiscore.setsec[1][6] );
			SetDlgItemText( hDlg, IDC_MEDIUM7, tempstr );

			if( hiscore.setmoves[2][6] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[2][6], hiscore.setmin[2][6], hiscore.setsec[2][6] );
			SetDlgItemText( hDlg, IDC_HARD7, tempstr );

			if( hiscore.setmoves[3][6] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[3][6], hiscore.setmin[3][6], hiscore.setsec[3][6] );
			SetDlgItemText( hDlg, IDC_GENIUS7, tempstr );


			if( hiscore.setmoves[0][7] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[0][7], hiscore.setmin[0][7], hiscore.setsec[0][7] );
			SetDlgItemText( hDlg, IDC_EASY8, tempstr );

			if( hiscore.setmoves[1][7] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[1][7], hiscore.setmin[1][7], hiscore.setsec[1][7] );
			SetDlgItemText( hDlg, IDC_MEDIUM8, tempstr );

			if( hiscore.setmoves[2][7] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[2][7], hiscore.setmin[2][7], hiscore.setsec[2][7] );
			SetDlgItemText( hDlg, IDC_HARD8, tempstr );

			if( hiscore.setmoves[3][7] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[3][7], hiscore.setmin[3][7], hiscore.setsec[3][7] );
			SetDlgItemText( hDlg, IDC_GENIUS8, tempstr );


			if( hiscore.setmoves[0][8] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[0][8], hiscore.setmin[0][8], hiscore.setsec[0][8] );
			SetDlgItemText( hDlg, IDC_EASY9, tempstr );

			if( hiscore.setmoves[1][8] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[1][8], hiscore.setmin[1][8], hiscore.setsec[1][8] );
			SetDlgItemText( hDlg, IDC_MEDIUM9, tempstr );

			if( hiscore.setmoves[2][8] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[2][8], hiscore.setmin[2][8], hiscore.setsec[2][8] );
			SetDlgItemText( hDlg, IDC_HARD9, tempstr );

			if( hiscore.setmoves[3][8] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[3][8], hiscore.setmin[3][8], hiscore.setsec[3][8] );
			SetDlgItemText( hDlg, IDC_GENIUS9, tempstr );


			if( hiscore.setmoves[0][9] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[0][9], hiscore.setmin[0][9], hiscore.setsec[0][9] );
			SetDlgItemText( hDlg, IDC_EASY10, tempstr );

			if( hiscore.setmoves[1][9] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[1][9], hiscore.setmin[1][9], hiscore.setsec[1][9] );
			SetDlgItemText( hDlg, IDC_MEDIUM10, tempstr );

			if( hiscore.setmoves[2][9] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[2][9], hiscore.setmin[2][9], hiscore.setsec[2][9] );
			SetDlgItemText( hDlg, IDC_HARD10, tempstr );

			if( hiscore.setmoves[3][9] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.setmoves[3][9], hiscore.setmin[3][9], hiscore.setsec[3][9] );
			SetDlgItemText( hDlg, IDC_GENIUS10, tempstr );



// Show Random Scores ...
			if( hiscore.randmoves[0] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.randmoves[0], hiscore.randmin[0], hiscore.randsec[0] );
			SetDlgItemText( hDlg, IDC_RAND1, tempstr );

			if( hiscore.randmoves[1] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.randmoves[1], hiscore.randmin[1], hiscore.randsec[1] );
			SetDlgItemText( hDlg, IDC_RAND2, tempstr );

			if( hiscore.randmoves[2] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.randmoves[2], hiscore.randmin[2], hiscore.randsec[2] );
			SetDlgItemText( hDlg, IDC_RAND3, tempstr );

			if( hiscore.randmoves[3] == 0 ) sprintf( tempstr, "-" );
			else sprintf( tempstr, "%d moves   (%.2d:%.2d)",
						hiscore.randmoves[3], hiscore.randmin[3], hiscore.randsec[3] );
			SetDlgItemText( hDlg, IDC_RAND4, tempstr );

			return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}

			if( LOWORD(wParam) == IDC_RESET )
			{
				ZeroMemory( &hiscore, sizeof(HISCORE) );
				DeleteFile( "hiscore.dat" );

				goto ShowHighScores;
			} // end if RESET button pushed

			break;
	}
    return FALSE;
}



LRESULT newgame( void )
{
	RECT rect, oldrect;
	int windowheight;

	HDC tempdc;

	int slotno, slotx, sloty;


// Set client size ...
	clientwidth = (32*difficulty) + INTERFACEWIDTH+RSWIDTH;
	clientheight = (32*difficulty) + 40;

	resety = (32*difficulty)-10;

	nextx = INTERFACEWIDTH+(difficulty*32)+20;
	nexty = (32*difficulty)-10;


// Set Window Size ...
	GetWindowRect( hwndmain, &oldrect );

	rect.top = 0;
	rect.bottom = (32*difficulty) + 40;
// Adjust for ads ...
//	rect.bottom += 60;


	rect.left = 0;
	rect.right =  (32*difficulty) + INTERFACEWIDTH+RSWIDTH;

	AdjustWindowRect( &rect, windowstyle, TRUE );

	rect.bottom -= rect.top;
	rect.top = 0;
	rect.right -= rect.left;
	rect.left = 0;

	if( centerwindow )
	{
		rect.left = (screenmaxx/2) - (rect.right/2);
		rect.top = (screenmaxy/2) - (rect.bottom/2);

		// Move ad window ...

		adwindowrect.top = 0;
		adwindowrect.bottom = 60;

		adwindowrect.left = 0;
		adwindowrect.right = 468;

		AdjustWindowRect( &adwindowrect, WS_DLGFRAME, TRUE );

		adwindowrect.bottom -= adwindowrect.top;
		adwindowrect.top = 0;
		adwindowrect.right -= adwindowrect.left;
		adwindowrect.left = 0;

		adwindowrect.left = (screenmaxx/2) - (adwindowrect.right/2);
		adwindowrect.top = screenmaxy - adwindowrect.bottom;

		if( adwindowrect.left < 0 ) adwindowrect.left = 0;
		if( adwindowrect.left+adwindowrect.right > screenmaxx ) adwindowrect.left = screenmaxx-adwindowrect.right;
		if( adwindowrect.top < 0 ) adwindowrect.top = 0;
		if( adwindowrect.top+adwindowrect.bottom > screenmaxy ) adwindowrect.top = screenmaxy-adwindowrect.bottom;

		SetWindowPos( hwndad, HWND_TOPMOST, adwindowrect.left, adwindowrect.top, adwindowrect.right, adwindowrect.bottom, SWP_SHOWWINDOW );


		// Check to see if ad overlays ...
		GetWindowRect( hwndad, &adwindowrect );
		if( rect.top + rect.bottom > adwindowrect.top )
		{
			windowheight = rect.bottom;

			rect.top = adwindowrect.top - windowheight;
			if( rect.top < 0 ) rect.top = 0;

			rect.bottom = windowheight;

		} // end if windows overlapped

		centerwindow = 0;
	}
	else
	{
		rect.left = oldrect.left;
		rect.top = oldrect.top;
	}


	if( rect.left < 0 ) rect.left = 0;
	if( rect.left+rect.right > screenmaxx ) rect.left = screenmaxx-rect.right;
	if( rect.top < 0 ) rect.top = 0;
	if( rect.top+rect.bottom > screenmaxy ) rect.top = screenmaxy-rect.bottom;


	SetWindowPos( hwndmain, HWND_TOP, rect.left, rect.top, rect.right, rect.bottom, NULL );

/*
// Move ad around ...
	if( adson )
	{
		Cydoor.Close( 3, hwndmain );
		adson = FALSE;
	}

	Cydoor.Show( 3, 3, 0, hwndmain, (difficulty-5) * 25, 50*difficulty, 468, 60, CY_DISABLE_EXTRA );
	adson = TRUE;
*/



// Draw interface ...
/*
	dc = GetDC( hwndmain );

	tempdc = CreateCompatibleDC( memdc );
	SelectObject( tempdc, hbmp_interface[0] );

	BitBlt( dc, 0, 0, 120, 400, tempdc, 0, 0, SRCCOPY );
	ReleaseDC( hwndmain, dc );
	DeleteDC( tempdc );
*/


	tempdc = CreateCompatibleDC( memdc );
hOldPal = SelectPalette( tempdc, hPal, FALSE );
RealizePalette( tempdc );
	SelectObject( tempdc, hbmp_interface[difficulty-5] );
	BitBlt( memdc, 0, 0, 120, (difficulty*32) + 40, tempdc, 0, 0, SRCCOPY );
SelectPalette( tempdc, hOldPal, FALSE );
	DeleteDC( tempdc );

	tempdc = CreateCompatibleDC( memdc );
hOldPal = SelectPalette( tempdc, hPal, FALSE );
RealizePalette( tempdc );
	SelectObject( tempdc, hbmp_rs[difficulty-5] );
	BitBlt( memdc, INTERFACEWIDTH+difficulty*32, 0, 120, (difficulty*32) + 40, tempdc, 0, 0, SRCCOPY );
SelectPalette( tempdc, hOldPal, FALSE );
	DeleteDC( tempdc );


	// Draw edge ...
	tempdc = CreateCompatibleDC( memdc );
hOldPal = SelectPalette( tempdc, hPal, FALSE );
RealizePalette( tempdc );

	SelectObject( tempdc, hbmp_edge );
	for( int row = 0; row < difficulty; row++ )
	{
		BitBlt( memdc, INTERFACEWIDTH+(row*32), 0, 32, 20, tempdc, 0, 0, SRCCOPY );
		BitBlt( memdc, INTERFACEWIDTH+(row*32), (difficulty*32)+20, 32, 20, tempdc, 0, 0, SRCCOPY );
	} // end draw each row
SelectPalette( tempdc, hOldPal, FALSE );
	DeleteDC( tempdc );



	tempdc = CreateCompatibleDC( memdc );
hOldPal = SelectPalette( tempdc, hPal, FALSE );
RealizePalette( tempdc );
	SelectObject( tempdc, hbmp_reset[resetpushed] );
	BitBlt( memdc, resetx, resety, 80, 35, tempdc, 0, 0, SRCCOPY );
SelectPalette( tempdc, hOldPal, FALSE );
	DeleteDC( tempdc );
	
	tempdc = CreateCompatibleDC( memdc );
hOldPal = SelectPalette( tempdc, hPal, FALSE );
RealizePalette( tempdc );
	SelectObject( tempdc, hbmp_next[nextpushed] );
	BitBlt( memdc, nextx, nexty, 80, 35, tempdc, 0, 0, SRCCOPY );
SelectPalette( tempdc, hOldPal, FALSE );
	DeleteDC( tempdc );


DoRandom:
// Set up board ...
	ZeroMemory( board, 8*8 );
	ZeroMemory( boardfade, 8*8 );


// Load or Generate Board ...
	if( randompuzzles )
	{
		int numofrandmoves;
		int index;
		int tempslotno;

		if( boardsaved )
		{
			memcpy( boardfade, tempboardsave, 64 );
			goto EndGenerateRandom;
		} // end if board already made

		numofrandmoves = (difficulty*difficulty) / 3;
		numofrandmoves += (rand()%(difficulty));


// numofrandmoves = 2;


		for( index = 0; index < numofrandmoves; index++ )
		{
			slotx = rand()%difficulty;
			sloty = rand()%difficulty;

			slotno = (sloty*difficulty) + slotx;

			if( boardfade[slotno] == UP ) boardfade[slotno] = 0;
			else boardfade[slotno] = UP;


// Do surrounding spaces ...
			if( slotx > 0 )
			{
				tempslotno = slotno-1;
				if( boardfade[tempslotno] == UP ) boardfade[tempslotno] = 0;
				else boardfade[tempslotno] = UP;
			} // end if valid slot

			if( slotx < difficulty-1 )
			{
				tempslotno = slotno+1;
				if( boardfade[tempslotno] == UP ) boardfade[tempslotno] = 0;
				else boardfade[tempslotno] = UP;
			} // end if valid slot


			if( sloty > 0 )
			{
				tempslotno = slotno-difficulty;
				if( boardfade[tempslotno] == UP ) boardfade[tempslotno] = 0;
				else boardfade[tempslotno] = UP;
			} // end if valid slot

			if( sloty < difficulty-1 )
			{
				tempslotno = slotno+difficulty;
				if( boardfade[tempslotno] == UP ) boardfade[tempslotno] = 0;
				else boardfade[tempslotno] = UP;
			} // end if valid slot

		} // end index loop


// Check to see if board is already completed ...

		for( slotno = 0; slotno < difficulty*difficulty; slotno++ )
		{
			if( boardfade[slotno] == UP ) break;
		} // end slotno loop

		if( slotno == difficulty*difficulty ) goto DoRandom;


/*
		for( sloty = 0; sloty < difficulty; sloty++ )
		{
			for( slotx = 0; slotx < difficulty; slotx++ )
			{
				slotno = (sloty*difficulty) + slotx;
				if( rand()%3 == 0 ) boardfade[slotno] = UP;
			} // end slotx loop

		} // end sloty loop
*/
		memcpy( tempboardsave, boardfade, 64 );
		boardsaved = 1;

EndGenerateRandom:

		isfading = 7;

	} // end if randompuzzles

	else
	{
		memcpy( boardfade, boardsave + (((difficulty-5)*10) * 64) + (boardnumber*64), 64 );

		isfading = 7;
	} // end if set levels



// Draw board ...
	drawboard();

	stopwatchon = 0;
	stopwatch = 0;
	minutes = 0;
	seconds = 0;

	numberofmoves = 0;

	drawnumberofmoves();
	drawstopwatch();

	drawrightsideinfo();


// Set up cursor zones in splashrect ...
	if( !inmenu )
	{
		SetRect( &splashrect[0], 120, 20, 120+(difficulty*32), 20+(difficulty*32) );
	
		SetRect( &splashrect[1], nextx, nexty, nextx+80, nexty+35 );
		SetRect( &splashrect[2], resetx, resety, resetx+80, resety+35 );
	
		oldmouseover = mouseover = 3;
	}

	
// Invalidate entire client area ...	
	InvalidateRect( hwndmain, NULL, 0 );

	return TRUE;

} // end newgame



LRESULT updatewindow( void )
{
	return TRUE;
} // end updatewindow



int drawboard( void )
{
	HDC tempdc;

	int slotno;
	int slotx, sloty;
	int screenx, screeny;

	if( insplashscreen ) return FALSE;


	slotno = 0;

	for( sloty = 0; sloty < difficulty; sloty++ )
	{
		screeny = (sloty * 32) + 20;

		for( slotx = 0; slotx < difficulty; slotx++ )
		{
			screenx = INTERFACEWIDTH + (slotx * 32);

			tempdc = CreateCompatibleDC( memdc );
hOldPal = SelectPalette( tempdc, hPal, FALSE );
RealizePalette( tempdc );
			SelectObject( tempdc, hbmp_light[ board[slotno] ] );

			BitBlt( memdc, screenx, screeny, 32, 32, tempdc, 0, 0, SRCCOPY );
SelectPalette( tempdc, hOldPal, FALSE );
			DeleteDC( tempdc );

			slotno++;
		} // end slotx loop

	} // end sloty loop

// TODO -- Take this out ?
	InvalidateRect( hwndmain, NULL, 0 );

	return TRUE;

} // end drawboard








int releaseobjects( void )
{
	static BOOL calledonce = FALSE;

	if( calledonce ) return FALSE;



	sprintf( debugstr, "releaseobjects()\n" );
	WRITETODEBUGFILE;


//	if( adson ) closeadwindow();


// Release Bitmaps ...
	if( hbmp_interface[0] ) DeleteObject( hbmp_interface[0] );
	if( hbmp_interface[1] ) DeleteObject( hbmp_interface[1] );
	if( hbmp_interface[2] ) DeleteObject( hbmp_interface[2] );
	if( hbmp_interface[3] ) DeleteObject( hbmp_interface[3] );

	if( hbmp_rs[0] ) DeleteObject( hbmp_rs[0] );
	if( hbmp_rs[1] ) DeleteObject( hbmp_rs[1] );
	if( hbmp_rs[2] ) DeleteObject( hbmp_rs[2] );
	if( hbmp_rs[3] ) DeleteObject( hbmp_rs[3] );

	if( hbmp_edge ) DeleteObject( hbmp_edge );


	if( hbmp_light[0] ) DeleteObject( hbmp_light[0] );
	if( hbmp_light[1] ) DeleteObject( hbmp_light[1] );
	if( hbmp_light[2] ) DeleteObject( hbmp_light[2] );
	if( hbmp_light[3] ) DeleteObject( hbmp_light[3] );
	if( hbmp_light[4] ) DeleteObject( hbmp_light[4] );
	if( hbmp_light[5] ) DeleteObject( hbmp_light[5] );
	if( hbmp_light[6] ) DeleteObject( hbmp_light[6] );
	if( hbmp_light[7] ) DeleteObject( hbmp_light[7] );

	if( hbmp_digit[0] ) DeleteObject( hbmp_digit[0] );
	if( hbmp_digit[1] ) DeleteObject( hbmp_digit[1] );
	if( hbmp_digit[2] ) DeleteObject( hbmp_digit[2] );
	if( hbmp_digit[3] ) DeleteObject( hbmp_digit[3] );
	if( hbmp_digit[4] ) DeleteObject( hbmp_digit[4] );
	if( hbmp_digit[5] ) DeleteObject( hbmp_digit[5] );
	if( hbmp_digit[6] ) DeleteObject( hbmp_digit[6] );
	if( hbmp_digit[7] ) DeleteObject( hbmp_digit[7] );
	if( hbmp_digit[8] ) DeleteObject( hbmp_digit[8] );
	if( hbmp_digit[9] ) DeleteObject( hbmp_digit[9] );
	if( hbmp_digit[10] ) DeleteObject( hbmp_digit[10] );

	if( hbmp_reset[0] ) DeleteObject( hbmp_reset[0] );
	if( hbmp_reset[1] ) DeleteObject( hbmp_reset[1] );

	if( hbmp_next[0] ) DeleteObject( hbmp_next[0] );
	if( hbmp_next[1] ) DeleteObject( hbmp_next[1] );

	DeleteObject( hPal );



	sprintf( debugstr, "\nGame Exit ... OK!\n" );
	WriteFile( debugfh, debugstr, strlen(debugstr), &numofbytesread, NULL );
	CloseHandle( debugfh );


	calledonce = TRUE;

	return TRUE;

} // end releaseobjects





void drawdigit( int digit, int x, int y )
{
	HDC tempdc;

	tempdc = CreateCompatibleDC( memdc );
hOldPal = SelectPalette( tempdc, hPal, FALSE );
RealizePalette( tempdc );
	SelectObject( tempdc, hbmp_digit[digit] );

	BitBlt( memdc, x, y, 12, 16, tempdc, 0, 0, SRCCOPY );
SelectPalette( tempdc, hOldPal, FALSE );
	DeleteDC( tempdc );

} // end drawdigit


void drawnumberofmoves( void )
{
	int digit1, digit2, digit3;
	int number;

	
	number = numberofmoves;

	digit1 = number/100;
	number -= digit1*100;
	digit2 = number/10;
	number -= digit2*10;
	digit3 = number;

	if( numberofmoves == 0 )
	{
		digit1 = 10;
		digit2 = 10;
		digit3 = 10;
	} // end if 0


	drawdigit( digit1, 42, MOVESY );
	drawdigit( digit2, 42+12, MOVESY );
	drawdigit( digit3, 42+24, MOVESY );

} // end drawnumberofmoves


void drawstopwatch( void )
{
	int digit1, digit2, digit3, digit4;

	RECT dirtyrect;
	int number;
	int number2;

	
	minutes = (stopwatch/60);
	seconds = stopwatch - (minutes*60);
	number = seconds;
	number2 = minutes;

	digit1 = number2/10;
	number2 -= digit1*10;
	digit2 = number2;

	digit3 = number/10;
	number -= digit3*10;
	digit4 = number;

	if( stopwatch == 0 )
	{
		digit1 = 10;
		digit2 = 10;
		digit3 = 10;
		digit4 = 10;
	} // end if stopwatch == 0

	drawdigit( digit1, 34, STOPWATCHY );
	drawdigit( digit2, 34+12, STOPWATCHY );
	
	drawdigit( digit3, 38+24, STOPWATCHY );
	drawdigit( digit4, 38+36, STOPWATCHY );

	dirtyrect.top = STOPWATCHY;
	dirtyrect.bottom = STOPWATCHY+16;
	dirtyrect.left = 34;
	dirtyrect.right = 38+36+12;

	InvalidateRect( hwndmain, &dirtyrect, 0 );

} // end drawstopwatch



void drawrightsideinfo( void )
{
	int digit1, digit2, digit3, digit4;

	RECT dirtyrect;
	int min, sec;
	int number;

	int x;

	
// Best Time ...
	if( randompuzzles )
	{
		min = hiscore.randmin[difficulty-5];
		sec = hiscore.randsec[difficulty-5];
	}
	else
	{
		min = hiscore.setmin[difficulty-5][boardnumber];
		sec = hiscore.setsec[difficulty-5][boardnumber];
	}

	if( (min == 0) && (sec == 0) )
	{
		digit1 = 10;
		digit2 = 10;
		digit3 = 10;
		digit4 = 10;
		goto DrawTime;
	}


	digit1 = min/10;
	min -= digit1*10;
	digit2 = min;

	digit3 = sec/10;
	sec -= digit3*10;
	digit4 = sec;


DrawTime:
	x = INTERFACEWIDTH + (difficulty*32) + BESTTIMEX; 

	drawdigit( digit1, x, BESTTIMEY );
	drawdigit( digit2, x+12, BESTTIMEY );
	
	drawdigit( digit3, x+4+24, BESTTIMEY );
	drawdigit( digit4, x+4+36, BESTTIMEY );

// Best Moves ...
	if( randompuzzles )
		number = hiscore.randmoves[difficulty-5];
	else
		number = hiscore.setmoves[difficulty-5][boardnumber];

	if( number == 0 )
	{
		digit1 = 10;
		digit2 = 10;
		digit3 = 10;
		goto DrawMoves;
	} 

	digit1 = number/100;
	number -= digit1*100;
	digit2 = number/10;
	number -= digit2*10;
	digit3 = number;

DrawMoves:
	x = INTERFACEWIDTH + (difficulty*32) + BESTMOVEX;

	drawdigit( digit1, x, BESTMOVEY );
	drawdigit( digit2, x+12, BESTMOVEY );
	drawdigit( digit3, x+24, BESTMOVEY );


// Current Level ...

	number = boardnumber+1;

	digit1 = number/10;
	number -= digit1*10;
	digit2 = number;

	if( randompuzzles )
	{
		digit1 = 10;
		digit2 = 10;
	}

	x = INTERFACEWIDTH + (difficulty*32) + LEVELX;

	drawdigit( digit1, x, LEVELY );
	drawdigit( digit2, x+12, LEVELY );



	dirtyrect.top = 0;
	dirtyrect.bottom = difficulty*32;
	dirtyrect.left = INTERFACEWIDTH + (difficulty*32);
	dirtyrect.right = INTERFACEWIDTH + (difficulty*32) + RSWIDTH;

	InvalidateRect( hwndmain, &dirtyrect, 0 );

} // end drawrightsideinfo










void CALLBACK mytimer(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
		tickcount++;	// Is this accurate enough ?
		if( --secondtimer == 0 )
		{
			secondtimer = 32;
			if( stopwatchon )
			{
				drawingstopwatch = 1;
				stopwatch++;

				if( stopwatch == 3600 ) stopwatch--; // Max out at 59 min, 59 sec ...
			}
		}

} // end mytimer








HPALETTE GetPalette( void )
{
	WORD wNumColors; // number of colors in color table
//	LPBITMAPINFO lpbmi; // pointer to BITMAPINFO structure (
//	HPALETTE hPal; // palette to be created
	LPLOGPALETTE lpPal; // pointer to a logical palette

	BYTE *tempptr;
//	BYTE *pDib;

//	lpbmi = (LPBITMAPINFO)pDib;

    wNumColors = 256; // get the number of colors 

    if (wNumColors != 0) {
        // allocate memory block for logical palette
        lpPal = (LPLOGPALETTE)malloc(sizeof(LOGPALETTE)+sizeof(PALETTEENTRY)*wNumColors);
        if (!lpPal) // if not enough memory
        return NULL; // return NULL
        // set version and number of palette entries
        lpPal->palVersion = 0x300;
        lpPal->palNumEntries = (WORD)wNumColors;

//		sprintf( tempstr, "%d colors retrieved", GetDIBColorTable( memdc, 0, 256, (RGBQUAD *)(&lpPal->palPalEntry[0].peRed) ) );
//		MessageBox( hwndmain, tempstr, "GetDIBColorTable()", MB_OK );

		

/*        
		for (int i = 0; i < (int)wNumColors; i++) {
			lpPal->palPalEntry[i].peRed = lpbmi->bmiColors[i].rgbRed;
			lpPal->palPalEntry[i].peGreen = lpbmi->bmiColors[i].rgbGreen;
			lpPal->palPalEntry[i].peBlue = lpbmi->bmiColors[i].rgbBlue;
			lpPal->palPalEntry[i].peFlags = 0;
        }
*/

	sprintf( filename, "pal.pcx" );

	filehandle = CreateFile( filename,           // open MYFILE.TXT 
                GENERIC_READ,              // open for reading 
                FILE_SHARE_READ,           // share for reading 
                NULL,                      // no security 
                OPEN_EXISTING,             // existing file only 
                FILE_ATTRIBUTE_NORMAL,     // normal file 
                NULL);                     // no attr. template 


	if( filehandle == INVALID_HANDLE_VALUE )
	{
		MessageBox( hwndmain, "Unable to open file 'pal.dat' ...", "Error", MB_OK|MB_ICONEXCLAMATION );
	} // end if can't find file

	else
	{
		SetFilePointer( filehandle, -768L, NULL, FILE_END );
		if( !ReadFile( filehandle, tempstr, 768, &numofbytesread, 0 ))
		{
			MessageBox( hwndmain, "Error reading file 'pal.dat' ...", "Error", MB_OK|MB_ICONEXCLAMATION );
		}

		CloseHandle( filehandle );
	}

	tempptr = (BYTE *)tempstr;

		for (int i = 0; i < (int)wNumColors; i++) {
			lpPal->palPalEntry[i].peRed = *tempptr++;
			lpPal->palPalEntry[i].peGreen = *tempptr++;
			lpPal->palPalEntry[i].peBlue = *tempptr++;
			lpPal->palPalEntry[i].peFlags = 0;
        }


        hPal = CreatePalette (lpPal); // create the palette and get handle to it

		if( hPal == NULL ) MessageBox( hwndmain, "Error in Create Palette()", NULL, MB_OK );
        free (lpPal);
    }
	return hPal;
}






HBITMAP LoadResourceBitmap(HINSTANCE hInstance, LPSTR lpString, 
                           HPALETTE FAR* lphPalette)
{
    HRSRC  hRsrc;
    HGLOBAL hGlobal;
    HBITMAP hBitmapFinal = NULL;
    LPBITMAPINFOHEADER  lpbi;
    HDC hdc;
    int iNumColors;

    if (hRsrc = FindResource(hInstance, lpString, RT_BITMAP))
       {
       hGlobal = LoadResource(hInstance, hRsrc);
       lpbi = (LPBITMAPINFOHEADER)LockResource(hGlobal);

       hdc = GetDC(NULL);
       *lphPalette =  CreateDIBPalette ((LPBITMAPINFO)lpbi, &iNumColors);
       if (*lphPalette)
          {
          SelectPalette(hdc,*lphPalette,FALSE);
          RealizePalette(hdc);
          }

       hBitmapFinal = CreateDIBitmap(hdc,
                   (LPBITMAPINFOHEADER)lpbi,
                   (LONG)CBM_INIT,
                   (LPSTR)lpbi + lpbi->biSize + iNumColors *
sizeof(RGBQUAD), 

                   (LPBITMAPINFO)lpbi,
                   DIB_RGB_COLORS );

       ReleaseDC(NULL,hdc);
       UnlockResource(hGlobal);
       FreeResource(hGlobal);
       }
    return (hBitmapFinal);
} 





HPALETTE CreateDIBPalette (LPBITMAPINFO lpbmi, LPINT lpiNumColors)
{ 

   LPBITMAPINFOHEADER  lpbi;
   LPLOGPALETTE     lpPal;
   HANDLE           hLogPal;
   HPALETTE         hPal = NULL;
   int              i;

   lpbi = (LPBITMAPINFOHEADER)lpbmi;
   if (lpbi->biBitCount <= 8)
       *lpiNumColors = (1 << lpbi->biBitCount);
   else
       *lpiNumColors = 0;  // No palette needed for 24 BPP DIB

   if (lpbi->biClrUsed > 0)
       *lpiNumColors = lpbi->biClrUsed;  // Use biClrUsed

   if (*lpiNumColors)
      {
      hLogPal = GlobalAlloc (GHND, sizeof (LOGPALETTE) +
                             sizeof (PALETTEENTRY) * (*lpiNumColors));
      lpPal = (LPLOGPALETTE) GlobalLock (hLogPal);
      lpPal->palVersion    = 0x300;
      lpPal->palNumEntries = *lpiNumColors;

      for (i = 0;  i < *lpiNumColors;  i++)
         {
         lpPal->palPalEntry[i].peRed   = lpbmi->bmiColors[i].rgbRed;
         lpPal->palPalEntry[i].peGreen = lpbmi->bmiColors[i].rgbGreen;
         lpPal->palPalEntry[i].peBlue  = lpbmi->bmiColors[i].rgbBlue;
         lpPal->palPalEntry[i].peFlags = 0;
         }
      hPal = CreatePalette (lpPal);
      GlobalUnlock (hLogPal);
      GlobalFree   (hLogPal);
   }
   return hPal;
} 




/*

BOOL openadwindow( void )
{
	return TRUE;


	sprintf( debugstr, "openadwindow()\n" );
	WRITETODEBUGFILE;


	// Show window ...
	hwndad = CreateDialog( hInst, "ADDIALOG", hwndmain, (DLGPROC)AdDialogProc );
	if( hwndad == NULL ) return FALSE;


	ShowWindow( hwndad, SW_SHOW );
	UpdateWindow( hwndad );

	adson = TRUE;

	sprintf( debugstr, "openadwindow complete.\n" );
	WRITETODEBUGFILE;

	return TRUE;
} // end openadwindow


BOOL closeadwindow( void )
{
	return TRUE;


	sprintf( debugstr, "closeadwindow()\n" );
	WRITETODEBUGFILE;

	DestroyWindow( hwndad );
	adson = FALSE;

	sprintf( debugstr, "closeadwindow complete.\n" );
	WRITETODEBUGFILE;

	return TRUE;
} // end closeadwindow

*/




BOOL RunMenu( void )
{
	HDC tempdc;
	MSG msg;
	RECT rect;
	int width, height;
	int index;

	int letterdestx[8];
	int letterdesty[8];
	int frame;
	DWORD frametickcount;


	clientwidth = 400;
	clientheight = 240;

	SetRect( &rect, 0, 0, 400, 240 );

	AdjustWindowRect( &rect, WS_DLGFRAME|WS_SYSMENU|WS_CAPTION, FALSE );

	// Center window ...
	width = rect.right - rect.left;
	height = rect.bottom - rect.top;

	rect.left = (screenmaxx/2) - (width/2);
	rect.top = (screenmaxy/2) - (height/2);
	rect.right = rect.left + width;
	rect.bottom = rect.top + height;


	hwndmenu = CreateWindow( "MenuWindowClass", "Blinkin'",
		WS_DLGFRAME|WS_SYSMENU|WS_CAPTION,
		rect.left, rect.top, width, height,
		NULL, NULL, hInst, NULL );


	SetRect( &rect, 0, 0, 400, 240 );
	FillRect( memdc, &rect, (HBRUSH)GetStockObject(BLACK_BRUSH));
	InvalidateRect( hwndmenu, NULL, FALSE );

	ShowWindow( hwndmenu, SW_SHOW );
	UpdateWindow( hwndmenu );

/*	tempdc = CreateCompatibleDC( memdc );
	SelectPalette( tempdc, hSplashpal, FALSE );
	RealizePalette( tempdc );

	hOldPal = SelectPalette( memdc, hSplashpal, FALSE );
	SelectPalette( GetDC(hwndmain), hSplashpal, FALSE );

	SelectObject( tempdc, hbmp_splash );
	BitBlt( memdc, 0, 0, 470, 250, tempdc, 0, 0, SRCCOPY );
//	SelectPalette( tempdc, hOldPal, FALSE );
	DeleteDC( tempdc );


	tickcount = 0;
	newtickcount = tickcount + 210;
	InvalidateRect( hwndmain, 0, 0 );


	hdc = BeginPaint(hwndmain, &ps);

	RealizePalette( memdc );

	BitBlt( hdc, 0, 0, 470, 250, memdc, 0, 0, SRCCOPY );
	EndPaint(hwndmain, &ps);


	ShowWindow(hwndmain, nCmdShow);
	UpdateWindow(hwndmain);

*/

	ShowWindow( hwndmenu, SW_SHOW );
	UpdateWindow( hwndmenu );


	insplashscreen = TRUE;	// Doing fancy text ...
	frame = 0;
	frametickcount = tickcount + 4;

	letterdestx[0] = 40;
	letterdesty[0] = 20;
	letterdestx[1] = 68;
	letterdesty[1] = 20;
	letterdestx[2] = 84;
	letterdesty[2] = 20;
	letterdestx[3] = 106;
	letterdesty[3] = 25;
	letterdestx[4] = 133;
	letterdesty[4] = 20;
	letterdestx[5] = 151;
	letterdesty[5] = 20;
	letterdestx[6] = 172;
	letterdesty[6] = 25;
	letterdestx[7] = 190;
	letterdesty[7] = 20;

	for( index = 0; index < 8; index++ )
	{
		letterdestx[index] += 74;

		letterx[index] = letterdestx[index] + ((index-4)*80);
		lettery[index] = letterdesty[index] + clientheight + (index*40);
	} // end index loop


	SetRect( &splashrect[0], 60, 80, 340, 112 );
	SetRect( &splashrect[1], 60, 120, 340, 152 );
	SetRect( &splashrect[2], 140, 175, 260, 235 );
	SetRect( &splashrect[3], 400-12-160, 180, 400-12, 230 );




// Menu screen message loop

	while( 1 )
	{
		if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
		{
			if( !GetMessage( &msg, NULL, 0, 0 ) )
			{
				for( index = 0; index < 8; index++ )
				{
					DeleteObject( hbmp_letter[index] );
					DeleteObject( hbmp_splash[index] );
				} // end index loop

				DestroyWindow( hwndmenu );
				return FALSE;
			} // end if WM_QUIT received

			if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
		else
		{
			if( playnow == TRUE ) break;

			if( insplashscreen )
			{
				if( frametickcount > tickcount ) continue;

				frametickcount = tickcount + 2;

				if( ++frame == 32 ) insplashscreen = FALSE;
	
				SetRect( &rect, 0, 0, 400, 240 );
				FillRect( memdc, &rect, (HBRUSH)GetStockObject(BLACK_BRUSH));

				// Do BIG B ...
					tempdc = CreateCompatibleDC( memdc );
					SelectPalette( tempdc, hSplashPal, FALSE );
					RealizePalette( tempdc );
				
					hOldPal = SelectPalette( memdc, hSplashPal, FALSE );
					SelectPalette( GetDC(hwndmenu), hSplashPal, FALSE );
				
					SelectObject( tempdc, hbmp_letter[0] );
					BitBlt( memdc, letterx[0], lettery[0], 36, 32, tempdc, 0, 0, SRCPAINT );
					DeleteDC( tempdc );
		
		
					// Update letter's location ...
					letterx[0] += ((letterdestx[0] - letterx[0]) / 4);
					lettery[0] += ((letterdesty[0] - lettery[0]) / 4);

				// Do other letters ...
				for( index = 1; index < 8; index++ )
				{
					if( frame < index ) break; // Stagger letters ...


					tempdc = CreateCompatibleDC( memdc );
					SelectPalette( tempdc, hSplashPal, FALSE );
					RealizePalette( tempdc );
				
					hOldPal = SelectPalette( memdc, hSplashPal, FALSE );
					SelectPalette( GetDC(hwndmenu), hSplashPal, FALSE );
				
					SelectObject( tempdc, hbmp_letter[index] );
					BitBlt( memdc, letterx[index], lettery[index], 32, 32, tempdc, 0, 0, SRCPAINT );
					DeleteDC( tempdc );
		
		
					// Update letter's location ...
					letterx[index] += ((letterdestx[index] - letterx[index]) / 4);
					lettery[index] += ((letterdesty[index] - lettery[index]) / 4);
				
				} // end loop one letter
		
				InvalidateRect( hwndmenu, NULL, TRUE );
				ShowWindow( hwndmenu, SW_SHOW );
				UpdateWindow( hwndmenu );


				if( !insplashscreen )
				{
					DrawSplash();
				} // end if last time, set up menu ... 

			} // end if in splashscreen

		}

	} // end splash screen message loop


	for( index = 0; index < 8; index++ )
	{
		DeleteObject( hbmp_letter[index] );
		DeleteObject( hbmp_splash[index] );
	} // end index loop

	DestroyWindow( hwndmenu );

	return TRUE;
} // end RunMenu






LRESULT CALLBACK SplashWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;

	int wmId, wmEvent;
	PAINTSTRUCT ps;

	int index;
	int cursorx, cursory;


	switch (message) 
	{
		case WM_DISPLAYCHANGE:
			RECT rect, oldrect;
			int windowheight;


			SystemParametersInfo( SPI_GETWORKAREA, NULL, &rect, NULL );
			screenmaxx = rect.right;
			screenmaxy = rect.bottom;

			// Center windows ...
			// Set Window Size ...
			GetWindowRect( hwndmenu, &oldrect );
		
			rect.top = 0;
			rect.bottom = 240;

			rect.left = 0;
			rect.right = 400;
		
			AdjustWindowRect( &rect, WS_DLGFRAME|WS_SYSMENU|WS_CAPTION, FALSE );
		
			rect.bottom -= rect.top;
			rect.top = 0;
			rect.right -= rect.left;
			rect.left = 0;
		
			rect.left = (screenmaxx/2) - (rect.right/2);
			rect.top = (screenmaxy/2) - (rect.bottom/2);
	
			// Move ad window ...
	
			adwindowrect.top = 0;
			adwindowrect.bottom = 60;
	
			adwindowrect.left = 0;
			adwindowrect.right = 468;
	
			AdjustWindowRect( &adwindowrect, WS_DLGFRAME, TRUE );
	
			adwindowrect.bottom -= adwindowrect.top;
			adwindowrect.top = 0;
			adwindowrect.right -= adwindowrect.left;
			adwindowrect.left = 0;
	
			adwindowrect.left = (screenmaxx/2) - (adwindowrect.right/2);
			adwindowrect.top = screenmaxy - adwindowrect.bottom;
	
			if( adwindowrect.left < 0 ) adwindowrect.left = 0;
			if( adwindowrect.left+adwindowrect.right > screenmaxx ) adwindowrect.left = screenmaxx-adwindowrect.right;
			if( adwindowrect.top < 0 ) adwindowrect.top = 0;
			if( adwindowrect.top+adwindowrect.bottom > screenmaxy ) adwindowrect.top = screenmaxy-adwindowrect.bottom;
	
			SetWindowPos( hwndad, HWND_TOPMOST, adwindowrect.left, adwindowrect.top, adwindowrect.right, adwindowrect.bottom, SWP_SHOWWINDOW );
	
	
			// Check to see if ad overlays ...
			GetWindowRect( hwndad, &adwindowrect );
			if( rect.top + rect.bottom > adwindowrect.top )
			{
				windowheight = rect.bottom;
	
				rect.top = adwindowrect.top - windowheight;
				if( rect.top < 0 ) rect.top = 0;
	
				rect.bottom = windowheight;
	
			} // end if windows overlapped
		
		
			if( rect.left < 0 ) rect.left = 0;
			if( rect.left+rect.right > screenmaxx ) rect.left = screenmaxx-rect.right;
			if( rect.top < 0 ) rect.top = 0;
			if( rect.top+rect.bottom > screenmaxy ) rect.top = screenmaxy-rect.bottom;
		
		
			SetWindowPos( hwndmenu, HWND_TOP, rect.left, rect.top, rect.right, rect.bottom, NULL );


		case WM_ACTIVATE:
		case WM_QUERYNEWPALETTE:
			hOldPal = SelectPalette( memdc, hPal, FALSE );
			RealizePalette( memdc );

			hdc = GetDC( hwndmenu );
			hOldPal = SelectPalette( hdc, hPal, FALSE );
			RealizePalette( hdc );
//			UpdateColors( hdc );
			ReleaseDC( hwndmenu, hdc );

			RealizePalette( memdc );
//			UpdateColors( memdc );
			InvalidateRect( hwndmenu, NULL, FALSE );
			break;

		case WM_PALETTEISCHANGING:
			RECT Rect;
			HDC hDC;

            if (wParam != (UINT)hWnd) { 
                GetClientRect(hWnd, &Rect); 
 
                hDC = GetDC(hWnd); 
                FillRect( hDC, &Rect, (HBRUSH)GetStockObject(BLACK_BRUSH)); 
                ReleaseDC(hWnd, hDC); 

                FillRect( memdc, &Rect, (HBRUSH)GetStockObject(BLACK_BRUSH)); 

				InvalidateRect( hwndmenu, NULL, TRUE );
            }
            break; 



		case WM_PALETTECHANGED:
			if( (HWND)wParam != hwndmenu )
			{
				hOldPal = SelectPalette( memdc, hSplashPal, TRUE );
				RealizePalette( memdc );
//				UpdateColors( memdc );

				hdc = GetDC( hwndmenu );
				hOldPal = SelectPalette( hdc, hSplashPal, TRUE );
				RealizePalette( hdc );
//				UpdateColors( hdc );

				ReleaseDC( hwndmenu, hdc );
				InvalidateRect( hwndmenu, NULL, TRUE );
			}
			break;


		case WM_MOUSEMOVE:
			if( insplashscreen ) break;

			cursorx = LOWORD(lParam);
			cursory = HIWORD(lParam);

			// Check mouseovers ...
			for( index = 0; index < 3; index++ )
			{
				if( cursorx < splashrect[index].left ) continue;
				if( cursorx > splashrect[index].right ) continue;
				if( cursory < splashrect[index].top ) continue;
				if( cursory > splashrect[index].bottom ) continue;

				break;
			} // end loop through rectangles

			mouseover = index;

			if( mouseover != oldmouseover )
			{
				DrawSplash();
				InvalidateRect( hwndmenu, NULL, FALSE );

				oldmouseover = mouseover;
			} // end if new mouseover

			if( mouseover < 3 )
			{
				SetCursor( hcursor[1] );
			}
			else
			{
				SetCursor( hcursor[0] );
			}

			break;



		case WM_LBUTTONDOWN:
			if( insplashscreen ) break;

			switch( mouseover )
			{
			case 0:		// INSTRUCTIONS
				mouseover = 4;

				if( soundon )
				{
					PlaySound( "SND_BLIP", GetModuleHandle(NULL), SND_RESOURCE|SND_ASYNC );
				}

				DrawSplash();
				InvalidateRect( hwndmenu, NULL, FALSE );

				WinHelp( hwndmenu, "Blinkin.hlp", HELP_CONTEXT, 1 );
				break;

			case 1:		// PLAY NOW!
				if( soundon )
				{
					PlaySound( "SND_BLIP", GetModuleHandle(NULL), SND_RESOURCE|SND_ASYNC );
				}

				inmenu = FALSE;
				playnow = TRUE;
				break;

			case 2:		// NSP LOGO
				mouseover = 4;

				if( soundon )
				{
					PlaySound( "SND_BLIP", GetModuleHandle(NULL), SND_RESOURCE|SND_ASYNC );
				}

				DrawSplash();
				InvalidateRect( hwndmenu, NULL, FALSE );

				ShellExecute( hwndmenu, "open", "http://www.nspgames.com", NULL, NULL, 0 );
				break;

/*			case 3:		// CYDOOR LOGO
				mouseover = 4;

				if( soundon )
				{
					PlaySound( "SND_BLIP", GetModuleHandle(NULL), SND_RESOURCE|SND_ASYNC );
				}

				DrawSplash();
				InvalidateRect( hwndmenu, NULL, FALSE );

				ShellExecute( hwndmenu, "open", "http://www.cydoor.com", NULL, NULL, 0 );
				break;
*/
			} // end switch on mouseover

			break; // end WM_LBUTTONDOWN



		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...

			RealizePalette( memdc );

			BitBlt( hdc, 0, 0, clientwidth, clientheight, memdc, 0, 0, SRCCOPY );
			EndPaint(hWnd, &ps);
			break;

		case WM_CLOSE:
			timeKillEvent( clockid );
			DestroyWindow( hwndmain );
			PostQuitMessage( 0 );
			break;


		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }

   return 0;

} // end SplashWndProc




void DrawSplash( void )
{
	RECT rect;
	HDC tempdc;
	int index;


	SetRect( &rect, 0, 64, 400, 240 );
	FillRect( memdc, &rect, (HBRUSH)GetStockObject(BLACK_BRUSH));


	for( index = 0; index < 3; index++ )
	{
		tempdc = CreateCompatibleDC( memdc );
		SelectPalette( tempdc, hSplashPal, FALSE );
		RealizePalette( tempdc );
	
		hOldPal = SelectPalette( memdc, hSplashPal, FALSE );
		SelectPalette( GetDC(hwndmenu), hSplashPal, FALSE );
	
		if( mouseover == index )
		{
			SelectObject( tempdc, hbmp_splash[index+4] );
		}
		else
		{
			SelectObject( tempdc, hbmp_splash[index] );
		}

		BitBlt( memdc, splashrect[index].left, splashrect[index].top,
			splashrect[index].right, splashrect[index].bottom, tempdc, 0, 0, SRCCOPY );

		DeleteDC( tempdc );
	} // end draw items

	InvalidateRect( hwndmenu, NULL, FALSE );

} // end DrawSplash